----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 01/11/2024 03:26:15 PM
-- Design Name: 
-- Module Name: Mode7 - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Mode7 is
 Port ( CLOCK_IN : in  STD_LOGIC;
        RESET : in  STD_LOGIC;
        TICK : in  STD_LOGIC;
        ledy_1 : out STD_LOGIC_VECTOR (7 downto 0)
        );
end Mode7;

architecture Behavioral of Mode7 is

signal count : natural := 0;
signal toggle : bit := '1';
signal leds : STD_LOGIC_VECTOR (7 downto 0):= "00000000";    


begin

ledy_1 <= leds; 

Mode7_proc: process(CLOCK_IN, RESET) is
	begin
	    if(RESET = '0') then
        count <= 0;
        toggle <= '1';
        leds <= "00000000";
		elsif(rising_edge(CLOCK_IN) and TICK = '1') then 

                if(count <= 7) then
                    if(toggle = '1') then
                        leds(count) <= '1';
                        count <= count + 1;
                        if(count = 7) then
                            toggle <= not toggle;
                            count <= 7;
                        end if;
                    else
                        leds(count) <= '0';
                        count <= count - 1;
                        if(count = 0) then
                            toggle <= not toggle;
                            count <= 0; 
                        end if;
                    end if;
                end if;
        end if;
end process;

end Behavioral;