----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 12.01.2024 19:35:04
-- Design Name: 
-- Module Name: Mode4 - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL; 
use ieee.numeric_std.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Mode4 is
 Port ( CLOCK_IN : in  STD_LOGIC; --Tutaj dajesz oryginalny sygna zegarowy
        TICK : in  STD_LOGIC; --Tutaj podajesz "tick" czyli szpilk tego zegara zmniejszony o dany prescalar
        ledy : out STD_LOGIC_VECTOR (7 downto 0) --Tutaj s diodki
        );
end Mode4;

architecture Behavioral of Mode4 is

signal count : natural := 0;
signal turnback : bit := '0';
signal leds : STD_LOGIC_VECTOR (7 downto 0);

begin

ledy <= leds;
leds <= "00000001";

Mode4_proc: process(CLOCK_IN) is
    begin 
        if(rising_edge(CLOCK_IN) and TICK = '1') then
                if(count <= 7) then
                    if(turnback = '0') then
                        leds <= std_logic_vector(unsigned(leds) sll 1);
                        count <= count + 1;
                        if(count = 7) then
                            turnback <= not turnback;
                        end if;
                    else
                        leds <= std_logic_vector(unsigned(leds) srl 1);
                        count <= count - 1;
                        if(count = 0) then
                            turnback <= not turnback;
                        end if;
                    end if;
                end if;
        end if;
end process;            

end Behavioral;
