----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 21.01.2024 21:12:10
-- Design Name: 
-- Module Name: TOP - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity TOP is
    Port ( btnR : in STD_LOGIC; -- Zmiana trybu wiecenia
           btnC : in STD_LOGIC; -- wcz/wycz
           btnL : in STD_LOGIC; -- Zmiana prdkoci wiecenia 
           clk : in STD_LOGIC;
           led : out STD_LOGIC_VECTOR (7 downto 0));
end TOP;

architecture Behavioral of TOP is

signal COUT : STD_LOGIC := '0';
signal BTNR_O : STD_LOGIC := '0';
signal BTNC_O : STD_LOGIC := '0';
signal BTNL_O : STD_LOGIC := '0';
signal LED_1 : STD_LOGIC_VECTOR (7 downto 0) := "00000000";
signal LED_2 : STD_LOGIC_VECTOR (7 downto 0) := "00000000";

begin

Debouncer: entity work.Debouncer PORT MAP (
        CLOCK_IN => clk,
        BIN => btnR,
        BOUT => BTNR_O
        );
Debouncer_1: entity work.Debouncer PORT MAP (
        CLOCK_IN => clk,
        BIN => btnC,
        BOUT => BTNC_O
        );  
Debouncer_2: entity work.Debouncer PORT MAP (
        CLOCK_IN => clk,
        BIN => btnL,
        BOUT => BTNL_O
        );      


end Behavioral;
