----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 12.01.2024 19:29:02
-- Design Name: 
-- Module Name: Mode3 - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Mode3 is
 Port ( CLOCK_IN : in  STD_LOGIC; --Tutaj dajesz oryginalny sygna zegarowy
        TICK : in  STD_LOGIC; --Tutaj podajesz "tick" czyli szpilk tego zegara zmniejszony o dany prescalar
        ledy : out STD_LOGIC_VECTOR (7 downto 0) --Tutaj s diodki
        );
end Mode3;

architecture Behavioral of Mode3 is

signal negate : bit := '1';
signal leds : STD_LOGIC_VECTOR (7 downto 0);

begin

ledy <= leds;
leds <= "11111111";

Mode3_proc: process(CLOCK_IN) is
    begin 
        if(rising_edge(CLOCK_IN) and TICK = '1') then
            if(negate = '1')then
                leds <= not leds;
                negate <= not negate;
            else
                leds <= not leds;
                negate <= not negate;
            end if;
        end if;
    end process;
end Behavioral;
